/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <phk@FreeBSD.ORG> wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a beer in return Daniel Cogo de Vargas
* and Ivon Eduardo Esser Rosa.
* ----------------------------------------------------------------------------
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package elementos;

import java.awt.event.KeyEvent;
import java.util.ArrayList;
import javax.swing.JPanel;
import jogo.Duke;
import jogo.Puffy;
import jogo.Tela;
import jogo.Tiro;
import jogo.Tux;


/**
 *
 * @author Acer
 */

public class Jogador extends Personagem {

    // criando vetor de tiros
    protected ArrayList<Tiro> vetorTiros;
   
    /**
     * Construtor de Jogador
     * @param nomeImagem - Nome da Imagem que aparecerá para o personagem
     * @param jp - Jpanel em que irá aparecer a imagem
     * @param px - Posição de X em que o objeto estará quando criado
     * @param py - Posição de Y em que o objeto estará quando criado
     * @param vd - Quantidade de vida com que o personagem iniciará
     */
    
    // construtor da classe jogador
    public Jogador (String nomeImagem, JPanel jp, int px, int py, int vd){
        super (nomeImagem, jp, px, py, vd);

        //criação do vetor de tiros
        vetorTiros = new ArrayList<Tiro>();
    }
    /**
     * Método para atirar, cada vez que acionado inclui um tiro no ArrayList
     * com tamanho máximo de 5 tiros (quantidade máxima de tiros para o jogador).
     */
    public void Atirar (){ // metodo para sempre imprimir 5 tiros na tela. 
        // 
        if (vetorTiros.size() < 5){
            vetorTiros.add(new Tiro(tela, this.getX()+this.getLargura(), this.getY()+this.getAltura()/2, 10));
        }
        
    }

   

    /**
     * Método para devolver o ArrayList de tiros
     * @return - Retorna vetor de tiros.
     */
    public ArrayList<Tiro> obterTiro(){  // retrona vetor , para receber o numero de tiros 
        return vetorTiros;
    }

     /**
     * Para tratar a tecla que está pressionada. Enquanto a tecla de direção
     * estiver pressionada, o objeto será movido para a respectiva direção.
     * Neste método é alterado os atributos dirX e dirY que são usados pelo
     * método mover
     * @param evento tecla que foi pressionada
     */
    public void teclaPressionada(KeyEvent evento) {
        // obtendo o código da tecla que foi pressionado
        int tecla = evento.getKeyCode();

        switch (tecla) {
            case KeyEvent.VK_LEFT:
                dirX = -1; // movendo para a esquerda
                break;
            case KeyEvent.VK_RIGHT:
                dirX = 1; // movendo para a direita
                break;
            case KeyEvent.VK_UP:
                dirY = -1; // movendo para cima
                break;
            case KeyEvent.VK_DOWN:
                dirY = 1; // movendo para baixo
                break;
            case KeyEvent.VK_SPACE:
                Atirar(); // atirar
                break;
            case KeyEvent.VK_E: // escudo de força
                if (this instanceof Puffy){ // se personagem for puffy
                    ((Puffy) this).ativarEscudo(); 
                }
                if (this instanceof Duke){ // se personagem for duke
                    ((Duke) this).ativarEscudo();
                }
                break;
            case KeyEvent.VK_B: // bomba aniquiladora (Tux e Puffy)
                if (this instanceof Tux){ // se personagem for tux
                    ((Tux) this).ativarBomba(); 
                }
                if (this instanceof Puffy){ // se personagem for puffy
                    ((Puffy) this).ativarBomba();
                }
                break;
            case KeyEvent.VK_R: // revitalizador (tux e duke)
                if (this instanceof Tux){ // se personagem for tux
                    ((Tux) this).ativarRevitalizador();
                }
                if (this instanceof Duke){ // se prsonagem for duke
                    ((Duke) this).ativarRevitalizador();
                }

        }
    }



    /**
     * Para de mover o objeto na direção da tecla que fora solta.
     * @param evento tecla que foi solta
     */
    public void teclaSolta(KeyEvent evento) {
        // obtendo o código da tecla que foi solta
        int tecla = evento.getKeyCode();

        switch (tecla) {
            case KeyEvent.VK_LEFT:
                dirX = 0; // para de mover para  esquerda
                break;
            case KeyEvent.VK_RIGHT:
                dirX = 0; // para de mover para  a direita
                break;
            case KeyEvent.VK_UP:
                dirY = 0; // para de mover para  cima
                break;
            case KeyEvent.VK_DOWN:
                dirY = 0; // para de mover para baixo
                break;


        }
    }


    
}
