/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <phk@FreeBSD.ORG> wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a beer in return Daniel Cogo de Vargas
* and Ivon Eduardo Esser Rosa.
* ----------------------------------------------------------------------------
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jogo;

import elementos.Jogador;
import javax.swing.JPanel;


/**
 * Construtor do Personagem > Jogador > Duke, que implementa o escudoForca e
 * o Revitalizador (ambos interfaces).
 * @author Daniel de Cogo Vargas e Ivon Eduardo Esser Rosa
 */
public class Duke extends Jogador implements escudoForca, Revitalizador {

    int tempo;
    boolean escudoAtivo;
    boolean revitAtivo;
/**
 * Construtor para o Jogador Duke, já define a imagem para "Duke.png"
 * @param jp
 * @param px
 * @param py
 * @param vd
 */
    public Duke (JPanel jp, int px, int py, int vd){
        super("Duke.png", jp, px, py, vd);
        tempo =0;
        escudoAtivo = false;
        revitAtivo = false;
    }

    /**
     * Ativa a arma especial Escudo de Força, quando ativada Jogador não perde
     * pontos de vida, está programada para ter uma duração de aproximadamente
     * 5 segundos.
     */
    public void ativarEscudo(){
        if (escudoAtivo == false) { // se escudo não estiver setado
            int poder = ((Tela) this.tela).pai.jPBPoder.getValue(); //passa valor do poder para variavel "poder"
            if (poder >= 50) { // se poder estiver maior que 50
                int poder_novo = poder - 50; // retira 50 do poder paa ativar escudo
                ((Tela) this.tela).pai.jPBPoder.setValue(poder_novo); // imprime na interface grafica
                this.alterarImagem("Duke_escudo.png"); // ativa escudo na imagem do personagem
                tempo = 1000; // temporiza para 5 seg
                escudoAtivo = true; // seta escudo
            }
        }
    }

    /**
     * Decrementará timer para definir tempo de duração do escudo.
     */
    public void decrementar(){
        if (tempo>0){ // se tempo for maior que zero
            tempo --; // decrementa até zero
        }else if(tempo == 0){ //então desativa escudo e volta a imagem anterior
            escudoAtivo=false;
            this.alterarImagem("Duke.png");
        }
    }

    /**
     * Ativa arma especial Revitalizador, quando ativado, transfere os pontos de
     * poder para pontos de vida, atingindo o nível máximo de vida de 100 pontos.
     */
    public void ativarRevitalizador(){ 
        revitAtivo = true; 
        if (revitAtivo == true){ // se revitalizador não estiver setado 
            int poder = ((Tela) this.tela).pai.jPBPoder.getValue(); 
            int vd = ((Tela) this.tela).pai.jPBVida.getValue();

            int nova_vida = poder + vd; // sema a quantia de poder com a quantia de vida
            int novo_poder = poder - (100 - vd); // e subtrai vida do poder

            if (nova_vida > 100){ // se quantia de vida for maior que cem
                ((Tela) this.tela).pai.jPBVida.setValue(100); // carrega vida com cem
                if (novo_poder <= 0){ // se quantia for menor que zero
                    ((Tela) this.tela).pai.jPBPoder.setValue(0); // carrega poder com 0
                }
                if (novo_poder > 0){ // se poder for maior que zero
                    ((Tela) this.tela).pai.jPBPoder.setValue(novo_poder); // carrega nova quantia de poder 
                }

            }
            if (nova_vida > 0 && nova_vida < 100 ){ // se vida estiver entre zero e cem
                ((Tela) this.tela).pai.jPBVida.setValue(nova_vida); // carrega vida com nova quantia de poder
                ((Tela) this.tela).pai.jPBPoder.setValue(0); // zera poder
            }

        }
        revitAtivo = false; // fim do procedimento de revitalização
    }

}
