/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jogo;


import elementos.Jogador;
import javax.swing.JPanel;


/**
 * Construtor do Personagem > Jogador > Puffy, que implementa o escudo de força
 * e a bomba aniquiladora (ambos interfaces).
 * @author Daniel de Cogo Vargas e Ivon Eduardo Esser ROsa
 */
public class Puffy extends Jogador implements escudoForca, bombaAniquiladora{

    int tempo;
    boolean escudoAtivo;
    protected boolean bombaAtiva;

    /**
     * Construtor para o Jogador Puffy, já define a imagem para "Puffy.png"
     * @param jp
     * @param px
     * @param py
     * @param vd
     */
    public Puffy (JPanel jp, int px, int py, int vd){
        super("Puffy.png", jp, px, py, vd);
        tempo = 0;
        escudoAtivo=false;
        bombaAtiva=false;
    }

    /**
     * Ativa a arma especial Escudo de Força, quando ativada Jogador não perde
     * pontos de vida, está programada para ter uma duração de aproximadamente
     * 5 segundos.
     */

    public void ativarEscudo(){ 
        if (escudoAtivo == false) { // se escudo estiver desativado
            int poder = ((Tela) this.tela).pai.jPBPoder.getValue(); 
            if (poder >= 50) { // se poder for maior que 50
                int poder_novo = poder - 50; // subtrair 50 do poder
                ((Tela) this.tela).pai.jPBPoder.setValue(poder_novo); // imprimir novo valor na interface
                this.alterarImagem("Puffy_escudo.png"); // apresentar nova imagem com escudo
                tempo = 1000; // temporiza 5 seg
                escudoAtivo = true; // desativa escudo
            }
        }

    }

    /**
     * Decrementará timer para definir tempo de duração do escudo.
     */
    public void decrementar(){ 
        if (tempo>0){ // teste para verificar se o tempo é valido
            tempo --;
        }else if(tempo == 0){ 
            escudoAtivo=false;
            this.alterarImagem("Puffy.png");
        }
    }


    /**
     * Ativa a arma especial BombaAniquiladora, quando ativa elimina todos os
     * inimigos e seus respectivos tiros da tela. Consome 100 pontos de poder.
     */
    public void ativarBomba(){ 
        bombaAtiva = true;
        if (bombaAtiva==true){ // se bomba estiver não estiver setada
        int poder = ((Tela) this.tela).pai.jPBPoder.getValue(); 
            if (poder >= 100) { // para ativar bomba retira-se todo o poder
                int poder_novo = poder - 100; 
                ((Tela) this.tela).pai.jPBPoder.setValue(poder_novo);
                ((Tela) this.tela).excluir();
                bombaAtiva = false;

            }
        }


                
    }
}
