/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <phk@FreeBSD.ORG> wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a beer in return Daniel Cogo de Vargas
* and Ivon Eduardo Esser Rosa.
* ----------------------------------------------------------------------------
*/

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jogo;

import elementos.Jogador;
import javax.swing.JPanel;


/**
 * Construtor do Personagem > Jogador > Tux, que implementa o Revitalizador
 * e a bomba aniquiladora (ambos interfaces).
 * @author Daniel de Cogo Vargas e Ivon Eduardo Esser ROsa
 */
public class Tux extends Jogador implements bombaAniquiladora, Revitalizador {

    boolean bombaAtiva;
    boolean revitAtivo;

    /**
     * Construtor para o Jogador Tux, já define a imagem para "Tux.png"
     * @param jp
     * @param px
     * @param py
     * @param vd
     */
    public Tux ( JPanel jp, int px, int py, int vd){
        super("penguin.png", jp, px, py, vd);
        bombaAtiva = false;
        revitAtivo = false;
    }

    /**
     * Ativa a arma especial BombaAniquiladora, quando ativa elimina todos os
     * inimigos e seus respectivos tiros da tela. Consome 100 pontos de poder.
     */
    public void ativarBomba() {
        bombaAtiva = true;
        if (bombaAtiva == true) { // testa se bomba estiversetada
            int poder = ((Tela) this.tela).pai.jPBPoder.getValue();
            if (poder >= 100) { // se poder for mair ou igua a cem
                int poder_novo = poder - 100; // retira poder
                ((Tela) this.tela).pai.jPBPoder.setValue(poder_novo);
                ((Tela) this.tela).excluir(); // exclui adversarios da tela
                bombaAtiva = false; // destiva bomba

            }
        }
    }

    /**
     * Ativa arma especial Revitalizador, quando ativado, transfere os pontos de
     * poder para pontos de vida, atingindo o nível máximo de vida de 100 pontos.
     */
    public void ativarRevitalizador(){ 
        revitAtivo = true;
        if (revitAtivo == true){ // se revitalizador não estiver setado
            int poder = ((Tela) this.tela).pai.jPBPoder.getValue(); 
            int vd = ((Tela) this.tela).pai.jPBVida.getValue();

            int nova_vida = poder + vd; //soma poder com vida
            int novo_poder = poder - (100 - vd); // e subtrai do poder

            if (nova_vida > 100){ //testes para saber se vida, repor a nova quantia de poder
                ((Tela) this.tela).pai.jPBVida.setValue(100);
                if (novo_poder <= 0){
                    ((Tela) this.tela).pai.jPBPoder.setValue(0);
                }
                if (novo_poder > 0){
                    ((Tela) this.tela).pai.jPBPoder.setValue(novo_poder);
                }

            }
            if (nova_vida > 0 && nova_vida < 100 ){ // caso poder chegue a zero
                ((Tela) this.tela).pai.jPBVida.setValue(nova_vida);
                ((Tela) this.tela).pai.jPBPoder.setValue(0);
            }

        }
        revitAtivo = false;
    }
}
